/* BlinkenLib
 * version 0.2 date 2005-01-27
 * Copyright 2004-2005 Stefan Schuermans <1stein@schuermans.info>
 * Copyleft: GNU public license - http://www.gnu.org/copyleft/gpl.html
 * a blinkenarea.org project
 * powered by eventphone.de
 */

#ifndef INC_BlinkenFrame
#define INC_BlinkenFrame

typedef struct sBlinkenFrame stBlinkenFrame;

stBlinkenFrame * BlinkenFrameNew( int height, int width, int channels, int maxval, int duration );

stBlinkenFrame * BlinkenFrameClone( stBlinkenFrame * pSrcFrame );

void BlinkenFrameFree( stBlinkenFrame * pFrame );

void BlinkenFrameClear( stBlinkenFrame * pFrame );

int BlinkenFrameGetHeight( stBlinkenFrame * pFrame );
int BlinkenFrameGetWidth( stBlinkenFrame * pFrame );
int BlinkenFrameGetChannels( stBlinkenFrame * pFrame );
int BlinkenFrameGetMaxval( stBlinkenFrame * pFrame );

int BlinkenFrameGetDuration( stBlinkenFrame * pFrame );
void BlinkenFrameSetDuration( stBlinkenFrame * pFrame, int duration );

unsigned char BlinkenFrameGetPixel( stBlinkenFrame * pFrame, int y, int x, int c );
void BlinkenFrameSetPixel( stBlinkenFrame * pFrame, int y, int x, int c, unsigned char val );

unsigned long BlinkenFrameGetColor( stBlinkenFrame * pFrame, int y, int x );
void BlinkenFrameSetColor( stBlinkenFrame * pFrame, int y, int x, unsigned long color );

void BlinkenFrameResize( stBlinkenFrame * pFrame, int height, int width, int channels, int maxval );
void BlinkenFrameScale( stBlinkenFrame * pFrame, int height, int width );

char * BlinkenFrameToString( stBlinkenFrame * pFrame );

#endif //#ifndef INC_BlinkenFrame

