/* BlinkenLib
 * version 0.2 date 2005-01-27
 * Copyright 2004-2005 Stefan Schuermans <1stein@schuermans.info>
 * Copyleft: GNU public license - http://www.gnu.org/copyleft/gpl.html
 * a blinkenarea.org project
 * powered by eventphone.de
 */

#ifndef INC_BlinkenMovie
#define INC_BlinkenMovie

#include "BlinkenFrame.h"

typedef struct sBlinkenMovie stBlinkenMovie;

stBlinkenMovie * BlinkenMovieNew( int height, int width, int channels, int maxval );

stBlinkenMovie * BlinkenMovieClone( stBlinkenMovie * pSrcMovie );

void BlinkenMovieFree( stBlinkenMovie * pMovie );

int BlinkenMovieGetHeight( stBlinkenMovie * pMovie );
int BlinkenMovieGetWidth( stBlinkenMovie * pMovie );
int BlinkenMovieGetChannels( stBlinkenMovie * pMovie );
int BlinkenMovieGetMaxval( stBlinkenMovie * pMovie );
int BlinkenMovieGetDuration( stBlinkenMovie * pMovie );

int BlinkenMovieGetInfoCnt( stBlinkenMovie * pMovie );
char * BlinkenMovieGetInfoType( stBlinkenMovie * pMovie, int infoNo );
char * BlinkenMovieGetInfoData( stBlinkenMovie * pMovie, int infoNo );
void BlinkenMovieSetInfo( stBlinkenMovie * pMovie, int infoNo, char * pInfoType, char * pInfoData );
void BlinkenMovieInsertInfo( stBlinkenMovie * pMovie, int infoNo, char * pInfoType, char * pInfoData );
void BlinkenMovieAppendInfo( stBlinkenMovie * pMovie, char * pInfoType, char * pInfoData );
void BlinkenMovieDeleteInfo( stBlinkenMovie * pMovie, int infoNo );
void BlinkenMovieDeleteInfos( stBlinkenMovie * pMovie );

int BlinkenMovieGetFrameCnt( stBlinkenMovie * pMovie );
stBlinkenFrame * BlinkenMovieGetFrame( stBlinkenMovie * pMovie, int frameNo );
void BlinkenMovieSetFrame( stBlinkenMovie * pMovie, int frameNo, stBlinkenFrame * pFrame );
void BlinkenMovieInsertFrame( stBlinkenMovie * pMovie, int frameNo, stBlinkenFrame * pFrame );
void BlinkenMovieAppendFrame( stBlinkenMovie * pMovie, stBlinkenFrame * pFrame );
void BlinkenMovieDeleteFrame( stBlinkenMovie * pMovie, int frameNo );
void BlinkenMovieDeleteFrames( stBlinkenMovie * pMovie );

void BlinkenMovieResize( stBlinkenMovie * pMovie, int height, int width, int channels, int maxval );
void BlinkenMovieScale( stBlinkenMovie * pMovie, int height, int width );

char * BlinkenMovieToString( stBlinkenMovie * pMovie );

stBlinkenMovie * BlinkenMovieLoadBlm( char * pFilename );
stBlinkenMovie * BlinkenMovieLoadBmm( char * pFilename );
stBlinkenMovie * BlinkenMovieLoadBml( char * pFilename );
stBlinkenMovie * BlinkenMovieLoadBbm( char * pFilename );
stBlinkenMovie * BlinkenMovieLoad( char * pFilename );

int BlinkenMovieSaveBlm( stBlinkenMovie * pMovie, char * pFilename );
int BlinkenMovieSaveBmm( stBlinkenMovie * pMovie, char * pFilename );
int BlinkenMovieSaveBml( stBlinkenMovie * pMovie, char * pFilename );
int BlinkenMovieSaveBbm( stBlinkenMovie * pMovie, char * pFilename );
int BlinkenMovieSave( stBlinkenMovie * pMovie, char * pFilename );

#endif //#ifndef INC_BlinkenMovie

